<html>
<head>
<title>OgreMemoryAllocatedObject.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMemoryAllocatedObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMemoryAllocatedObject_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __AllocatedObject_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __AllocatedObject_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Anything that has done a #define new &lt;blah&gt; will screw operator new definitions up</span>
<a name="l00035"></a>00035 <span class="comment">// so undefine</span>
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef new</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#  undef new</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#ifdef delete</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#  undef delete</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre
<a name="l00044"></a>00044 {
<a name="l00056"></a>00056     <span class="keyword">template</span> &lt;<span class="keyword">class</span> Alloc&gt;
<a name="l00057"></a><a class="code" href="classOgre_1_1AllocatedObject.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a366445eb206e55a2199267b8b9089ebb">00060</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a>()
<a name="l00061"></a>00061         { }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a499773d35ca98b2df7c2699fc8c1bea2">00063</a>         ~<a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a>()
<a name="l00064"></a>00064         { }
<a name="l00065"></a>00065 
<a name="l00067"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">00067</a>         <span class="keywordtype">void</span>* operator new(<span class="keywordtype">size_t</span> sz, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* func)
<a name="l00068"></a>00068         {
<a name="l00069"></a>00069             <span class="keywordflow">return</span> Alloc::allocateBytes(sz, file, line, func);
<a name="l00070"></a>00070         }
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">00072</a>         <span class="keywordtype">void</span>* operator new(<span class="keywordtype">size_t</span> sz)
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074             <span class="keywordflow">return</span> Alloc::allocateBytes(sz);
<a name="l00075"></a>00075         }
<a name="l00076"></a>00076 
<a name="l00078"></a><a class="code" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">00078</a>         <span class="keywordtype">void</span>* operator new(<span class="keywordtype">size_t</span> sz, <span class="keywordtype">void</span>* ptr)
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080             (void) sz;
<a name="l00081"></a>00081             <span class="keywordflow">return</span> ptr;
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">00085</a>         <span class="keywordtype">void</span>* operator new[] ( <span class="keywordtype">size_t</span> sz, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* func )
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087             <span class="keywordflow">return</span> Alloc::allocateBytes(sz, file, line, func);
<a name="l00088"></a>00088         }
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">00090</a>         <span class="keywordtype">void</span>* operator new[] ( <span class="keywordtype">size_t</span> sz )
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092             <span class="keywordflow">return</span> Alloc::allocateBytes(sz);
<a name="l00093"></a>00093         }
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">00095</a>         <span class="keywordtype">void</span> operator delete( <span class="keywordtype">void</span>* ptr )
<a name="l00096"></a>00096         {
<a name="l00097"></a>00097             Alloc::deallocateBytes(ptr);
<a name="l00098"></a>00098         }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="comment">// Corresponding operator for placement delete (second param same as the first)</span>
<a name="l00101"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">00101</a>         <span class="keywordtype">void</span> operator delete( <span class="keywordtype">void</span>* ptr, <span class="keywordtype">void</span>* )
<a name="l00102"></a>00102         {
<a name="l00103"></a>00103             Alloc::deallocateBytes(ptr);
<a name="l00104"></a>00104         }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         <span class="comment">// only called if there is an exception in corresponding &#39;new&#39;</span>
<a name="l00107"></a><a class="code" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">00107</a>         <span class="keywordtype">void</span> operator delete( <span class="keywordtype">void</span>* ptr, <span class="keyword">const</span> <span class="keywordtype">char</span>* , <span class="keywordtype">int</span> , <span class="keyword">const</span> <span class="keywordtype">char</span>*  )
<a name="l00108"></a>00108         {
<a name="l00109"></a>00109             Alloc::deallocateBytes(ptr);
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">00112</a>         <span class="keywordtype">void</span> operator delete[] ( <span class="keywordtype">void</span>* ptr )
<a name="l00113"></a>00113         {
<a name="l00114"></a>00114             Alloc::deallocateBytes(ptr);
<a name="l00115"></a>00115         }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">00118</a>         <span class="keywordtype">void</span> operator delete[] ( <span class="keywordtype">void</span>* ptr, <span class="keyword">const</span> <span class="keywordtype">char</span>* , <span class="keywordtype">int</span> , <span class="keyword">const</span> <span class="keywordtype">char</span>*  )
<a name="l00119"></a>00119         {
<a name="l00120"></a>00120             Alloc::deallocateBytes(ptr);
<a name="l00121"></a>00121         }
<a name="l00122"></a>00122     };
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
